#include "head.h"

int RightMargin=0;
int LeftMargin=0;
unsigned Fmt=0;
extern FILE *Log;
extern int _delright (int x, char *str);

extern int wleft (int x, char *str);

void strip (char *S) {
  char *p;

  p=S+strlen(S)-1;
  while (p>S && (*p==' ' || *p=='\t')) *p--=0;
} //strip

void BreakLine (char *S, char *SS, int X) {
  delright(X,S);
  strcpy(SS,tstr);
  strip(SS);
} //BreakLine

int checkquote(char *S, char *SS, char *res) {
  char *p=S;

  *res=0;
  if (*S=='>'||*S=='|'||*S==':') {
    while (*p=='>'||*p=='|'||*p==':'||*p==' '||*p=='\t') p++;
    if (p-S>10) return 0;
    strncpy(res,S,p-S);
    res[p-S]=0;
    if (strncmp(S,SS,p-S)) return 0;
    p=SS+(p-S);
    while (*p==' '||*p=='\t') p++;
    if (*p=='>'||*p=='|'||*p==':') return 0;
    return 1;
  }
  else {
    if (*SS==0||*SS=='>'||*SS=='|'||*SS==':'||*SS==' '||*SS=='\t') return 0;
    return 1;
  }
} //checkquote

void Edit::putl (char *S) {
  modified=1;
  putline(S);
} //Edit::putl


int Edit::Format() {

  char S[2*MAXSTR+10], SS[2*MAXSTR+10], temp[2*MAXSTR+10], quote[12];
  char S1[2*MAXSTR+10];
  int X0,X1=-1;
  int Y=ypos;
  int y0=ypos;
  int Lineno1=Lineno;
  int done=0;

  if (!Fmt) return 0;
  if (RightMargin<=0) return 0;
  strcpy(S,strbuf);
  strip(S);
  if (len(S)<=RightMargin) return 0;

  SS[0]=0;

  UndoBuf->put(ENDGROUP12,oldx,Lineno,Lines);

  while (len(S)>RightMargin) {
    X0=len(S);
    while (X0>=RightMargin)  // 饬,  ࠧ१ ப
      X0=wleft(X0,S);
    if (X0<=12) X0=RightMargin;

    done=1;
    if (ypos==Y) X1=xpos-X0;

    BreakLine(S,SS,X0);  // ० ப

    if (Log) fprintf(Log,"0 S='%s'\n0 SS='%s'\n",S,SS);

    putl(S);
    //strcpy(temp,S);

    while (len(SS)>RightMargin) {
      strcpy(S1,SS);
      X0=len(S1);
      while (X0>=RightMargin)  // 饬,  ࠧ१ ப
        X0=wleft(X0,S1);
      if (X0<=12) X0=RightMargin;
      BreakLine(S1,SS,X0);  // ० ப
      InsLine(S1,0,0);
      Lines++;
    } //while

    strcpy(S,GetVStr(GetNext(Cur)));

    if (!checkquote(temp,S,quote)) { // ⠢塞  ਧ 
      strcpy(temp,quote);
      strcat(temp,SS);
      if (ypos==Y && xpos>X0) {
        if (ypos<(B.Y-A.Y)) {
          ypos++; Y++;
          InsLine(temp,1,0);
        }
        else {
          Scr=GetNext(Scr);
          InsLine(temp,0,0);
        }
        xpos=(X1>0)?X1:0;
        xoffset=0;
        if (Lineno>=0) Lineno++;
        if (Lineno1>=0) Lineno1++;
        Lines++;
      }
      else {
        InsLine(temp,1,0);
        Lines++;
      }
    }
    else {  //  ਧ 
      if (ypos==Y && xpos>X0) { // 室   ᫥. ப
        xpos=(X1>0)?X1:0;
        xoffset=0;
        if (Lineno1>=0) Lineno1++;
        if (ypos<(B.Y-A.Y)) {
          ypos++;
          Y++;
        }
        else {
          Scr=GetNext(Scr);
          scrdn(0);
          if (y0>1) y0--;
        }
      }
      else
        ypos++;
      if (Lineno>=0) Lineno++;
      Cur=GetNext(Cur);
      strcpy(temp,quote);
      strcat(temp,SS);
      strcat(temp," ");
      strcat(temp,S+strlen(quote));
      putl(temp);
    } //if (!checkquote(temp,S,quote))

    getline(S);
    strip(S);
  } //while (len(S)>RightMargin)

  ypos=Y;
  int i;
  for (i=0, Cur=Scr; i<ypos; i++)
    Cur=GetNext(Cur);

  if (done) {
    modified=0; //???
    Rect R=getCoord();
    Dirty.Assign(R.A.X,R.A.Y+y0,R.B.X,R.B.Y);
    ReDraw();
  }


  UndoBuf->put(GROUP12,oldx,Lineno,Lines);
  Lineno=Lineno1;
  putflag=0;
  getline(strbuf);


  return 1;
} //Edit::Format
